/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/mikrokopter-genom3/work/templates/ros/client/ros/mikrokopter/srv/get_sensor_rate.srv
 *
 */


#ifndef MIKROKOPTER_MESSAGE_GET_SENSOR_RATERESPONSE_H
#define MIKROKOPTER_MESSAGE_GET_SENSOR_RATERESPONSE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <mikrokopter/mikrokopter_ids_sensor_time_s_rate_s.h>

namespace mikrokopter
{
template <class ContainerAllocator>
struct get_sensor_rateResponse_
{
  typedef get_sensor_rateResponse_<ContainerAllocator> Type;

  get_sensor_rateResponse_()
    : genom_success(false)
    , genom_exdetail()
    , rate()  {
    }
  get_sensor_rateResponse_(const ContainerAllocator& _alloc)
    : genom_success(false)
    , genom_exdetail(_alloc)
    , rate(_alloc)  {
    }



   typedef uint8_t _genom_success_type;
  _genom_success_type genom_success;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _genom_exdetail_type;
  _genom_exdetail_type genom_exdetail;

   typedef  ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator>  _rate_type;
  _rate_type rate;




  typedef boost::shared_ptr< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> const> ConstPtr;

}; // struct get_sensor_rateResponse_

typedef ::mikrokopter::get_sensor_rateResponse_<std::allocator<void> > get_sensor_rateResponse;

typedef boost::shared_ptr< ::mikrokopter::get_sensor_rateResponse > get_sensor_rateResponsePtr;
typedef boost::shared_ptr< ::mikrokopter::get_sensor_rateResponse const> get_sensor_rateResponseConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mikrokopter

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'mikrokopter': ['mikrokopter/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "1b183b56d5b80566dacc363b97906198";
  }

  static const char* value(const ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x1b183b56d5b80566ULL;
  static const uint64_t static_value2 = 0xdacc363b97906198ULL;
};

template<class ContainerAllocator>
struct DataType< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mikrokopter/get_sensor_rateResponse";
  }

  static const char* value(const ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
{
  static const char* value()
  {
    return "bool genom_success\n\
string genom_exdetail\n\
mikrokopter_ids_sensor_time_s_rate_s rate\n\
\n\
\n\
================================================================================\n\
MSG: mikrokopter/mikrokopter_ids_sensor_time_s_rate_s\n\
# IDL struct ::mikrokopter::ids::sensor_time_s::rate_s\n\
float64 imu\n\
float64 motor\n\
float64 battery\n\
";
  }

  static const char* value(const ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.genom_success);
      stream.next(m.genom_exdetail);
      stream.next(m.rate);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct get_sensor_rateResponse_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mikrokopter::get_sensor_rateResponse_<ContainerAllocator>& v)
  {
    s << indent << "genom_success: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.genom_success);
    s << indent << "genom_exdetail: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.genom_exdetail);
    s << indent << "rate: ";
    s << std::endl;
    Printer< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >::stream(s, indent + "  ", v.rate);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MIKROKOPTER_MESSAGE_GET_SENSOR_RATERESPONSE_H
