/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/robots/mikrokopter-genom3/work/templates/ros/client/ros/mikrokopter/msg/mikrokopter_ids_sensor_time_s_rate_s.msg
 *
 */


#ifndef MIKROKOPTER_MESSAGE_MIKROKOPTER_IDS_SENSOR_TIME_S_RATE_S_H
#define MIKROKOPTER_MESSAGE_MIKROKOPTER_IDS_SENSOR_TIME_S_RATE_S_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace mikrokopter
{
template <class ContainerAllocator>
struct mikrokopter_ids_sensor_time_s_rate_s_
{
  typedef mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> Type;

  mikrokopter_ids_sensor_time_s_rate_s_()
    : imu(0.0)
    , motor(0.0)
    , battery(0.0)  {
    }
  mikrokopter_ids_sensor_time_s_rate_s_(const ContainerAllocator& _alloc)
    : imu(0.0)
    , motor(0.0)
    , battery(0.0)  {
    }



   typedef double _imu_type;
  _imu_type imu;

   typedef double _motor_type;
  _motor_type motor;

   typedef double _battery_type;
  _battery_type battery;




  typedef boost::shared_ptr< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> const> ConstPtr;

}; // struct mikrokopter_ids_sensor_time_s_rate_s_

typedef ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<std::allocator<void> > mikrokopter_ids_sensor_time_s_rate_s;

typedef boost::shared_ptr< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s > mikrokopter_ids_sensor_time_s_rate_sPtr;
typedef boost::shared_ptr< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s const> mikrokopter_ids_sensor_time_s_rate_sConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace mikrokopter

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'mikrokopter': ['mikrokopter/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "b97a5e1f3c3241d1ed4933761f059140";
  }

  static const char* value(const ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xb97a5e1f3c3241d1ULL;
  static const uint64_t static_value2 = 0xed4933761f059140ULL;
};

template<class ContainerAllocator>
struct DataType< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "mikrokopter/mikrokopter_ids_sensor_time_s_rate_s";
  }

  static const char* value(const ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::mikrokopter::ids::sensor_time_s::rate_s\n\
float64 imu\n\
float64 motor\n\
float64 battery\n\
";
  }

  static const char* value(const ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.imu);
      stream.next(m.motor);
      stream.next(m.battery);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct mikrokopter_ids_sensor_time_s_rate_s_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::mikrokopter::mikrokopter_ids_sensor_time_s_rate_s_<ContainerAllocator>& v)
  {
    s << indent << "imu: ";
    Printer<double>::stream(s, indent + "  ", v.imu);
    s << indent << "motor: ";
    Printer<double>::stream(s, indent + "  ", v.motor);
    s << indent << "battery: ";
    Printer<double>::stream(s, indent + "  ", v.battery);
  }
};

} // namespace message_operations
} // namespace ros

#endif // MIKROKOPTER_MESSAGE_MIKROKOPTER_IDS_SENSOR_TIME_S_RATE_S_H
